package com.ejie.ab79.dao.procedimientos;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.procedimientos.Aplicaciones;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProcedimientosDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ProcedimientosDaoImpl implements ProcedimientosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDPROCEDIMIENTO", "IDDIRECCION", "IDAREA",
			"CODPROCEDUREID", "CAMPOSTITULOEXPEDIENTE", "FECHAREGISTRO", "USUARIOREGISTRO", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Procedimientos> rwMap = new RowMapper<Procedimientos>() {
		@Override
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"), resultSet.getString("CODPROCEDUREID"),
					resultSet.getString("CAMPOSTITULOEXPEDIENTE"), resultSet.getString("USUARIOREGISTRO"),
					new Direcciones(resultSet.getInt("IDDIRECCION")), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"),
					new Aplicaciones(null, null, null, resultSet.getString("URLAPLICACION"), null, null));
		}
	};

	private RowMapper<Procedimientos> rwMapListados = new RowMapper<Procedimientos>() {
		@Override
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"), resultSet.getString("CODPROCEDUREID"),
					resultSet.getString("CAMPOSTITULOEXPEDIENTE"), resultSet.getString("USUARIOREGISTRO"),
					new Direcciones(resultSet.getInt("IDDIRECCION")), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	private RowMapper<Procedimientos> rwMapPK = new RowMapper<Procedimientos>() {
		@Override
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"));
		}
	};

	private RowMapper<Procedimientos> rwMapProcedureId = new RowMapper<Procedimientos>() {
		@Override
		public Procedimientos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Procedimientos procedimiento = new Procedimientos();

			procedimiento.setIdProcedimiento(
					resultSet.getObject("IDPROCEDIMIENTO") != null ? resultSet.getInt("IDPROCEDIMIENTO") : null);
			procedimiento.setCodProcedureId(
					resultSet.getObject("CODPROCEDUREID") != null ? resultSet.getString("CODPROCEDUREID") : null);

			return procedimiento;

		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<Procedimientos>> rwMapJerarquia = new RowMapper<JerarquiaDto<Procedimientos>>() {
		@Override
		public JerarquiaDto<Procedimientos> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Procedimientos procedimientos = new Procedimientos(resultSet.getInt("IDPROCEDIMIENTO"),
					resultSet.getString("CODPROCEDUREID"), resultSet.getString("CAMPOSTITULOEXPEDIENTE"),
					resultSet.getString("USUARIOREGISTRO"), new Direcciones(resultSet.getInt("IDDIRECCION")),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					new Aplicaciones(null, null, null, resultSet.getString("URLAPLICACION"), null, null));

			JerarquiaDto<Procedimientos> jerarquia = new JerarquiaDto<Procedimientos>();
			jerarquia.setModel(procedimientos);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds a single row in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Procedimientos
	 */
	@Override
	@Transactional(readOnly = true)
	public Procedimientos find(Procedimientos procedimientos) {
		String query = "SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_DIRECCION IDDIRECCION, t1.COD_PROCEDURE_ID CODPROCEDUREID, t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t2.URL_APLICACION URLAPLICACION FROM PROCEDIMIENTOS t1, APLICACIONES t2 WHERE t1.ID_APLICACION = t2.ID_APLICACION(+) AND t1.ID_PROCEDIMIENTO = ?  ";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMap,
				procedimientos.getIdProcedimiento());
		return DataAccessUtils.uniqueResult(procedimientosList);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<Procedimientos> getMultiple(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterProcedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, Procedimientos.class, params,
				"ID_PROCEDIMIENTO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Procedimientos>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Procedimientos> findAll(Procedimientos procedimientos, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t2.URL_APLICACION URLAPLICACION ");
		query.append("FROM PROCEDIMIENTOS t1, APLICACIONES t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(procedimientos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_APLICACION = t2.ID_APLICACION(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Procedimientos> obtenerProcedimientosInicioOficio() {
		String query = "SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,"
				+ "t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t2.URL_APLICACION URLAPLICACION "
				+ "FROM PROCEDIMIENTOS t1, APLICACIONES t2 "
				+ "WHERE t1.ID_APLICACION = t2.ID_APLICACION(+) AND t1.INICIO_OFICIO = ? AND t2.CODIGO_APLICACION = ? ";

		List<Object> params = new ArrayList<Object>();
		params.add(Constantes.PROCEDIMIENTO_INICIO_OFICIO);
		params.add(Constantes.CODIGO_APLICACION.toUpperCase());

		return this.jdbcTemplate.query(query, params.toArray(), this.rwMap);
	}

	@Override
	public List<Procedimientos> obtenerProcedimientosInicioOficioByInspeccion(Integer idInspeccion) {
		String query = "SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, "
				+ " t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, "
				+ " t2.URL_APLICACION URLAPLICACION " + " FROM PROCEDIMIENTOS t1, APLICACIONES t2, INSPECCIONES t3 "
				+ " WHERE t1.ID_APLICACION = t2.ID_APLICACION(+) AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t3.ID_INSPECCION = ? "
				+ " AND t2.CODIGO_APLICACION = ? AND t1.INICIO_OFICIO = ? ";

		List<Object> params = new ArrayList<Object>();
		params.add(idInspeccion);
		params.add(Constantes.AB79);
		params.add(Constantes.INICIO_OFICIO);

		return this.jdbcTemplate.query(query, params.toArray(), this.rwMap);
	}

	/**
	 * Finds rows in the Procedimientos table using like.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Procedimientos>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Procedimientos> findAllLike(Procedimientos procedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t2.URL_APLICACION URLAPLICACION ");
		query.append("FROM PROCEDIMIENTOS t1, APLICACIONES t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_APLICACION = t2.ID_APLICACION(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Procedimientos table.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(Procedimientos procedimientos) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PROCEDIMIENTOS t1, APLICACIONES t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(procedimientos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_APLICACION = t2.ID_APLICACION(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Procedimientos table using like.
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Procedimientos procedimientos, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PROCEDIMIENTOS t1, APLICACIONES t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_APLICACION = t2.ID_APLICACION(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Procedimientos selected for rup_table
	 *
	 * @param procedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> reorderSelection(Procedimientos procedimientos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(procedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, Procedimientos.class,
				filterParamList, "ID_PROCEDIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            Procedimientos
	 * @param searchParams
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> search(Procedimientos filterParams, Procedimientos searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, Procedimientos.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_PROCEDIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterprocedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Procedimientos filterprocedimientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		query.append("FROM PROCEDIMIENTOS t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterprocedimientos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, Procedimientos.class,
				query, params, "ID_PROCEDIMIENTO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical Procedimientos table.
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Procedimientos>>
	 */
	@Override
	public List<JerarquiaDto<Procedimientos>> findAllLikeJerarquia(Procedimientos filterProcedimientos,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.ID_DIRECCION IDDIRECCION,t1.COD_PROCEDURE_ID CODPROCEDUREID,t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_PROCEDIMIENTO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					ProcedimientosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(Procedimientos filterProcedimientos, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_PROCEDIMIENTO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterProcedimientos
	 *            Procedimientos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Procedimientos>>
	 */
	@Override
	public List<TableRowDto<Procedimientos>> findAllChild(Procedimientos filterProcedimientos,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM PROCEDIMIENTOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROCEDIMIENTOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProcedimientos, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_PROCEDIMIENTO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<Procedimientos>(this.rwMapPK, "ID_PROCEDIMIENTO"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Procedimientos entity
	 *
	 * @param procedimientos
	 *            Procedimientos Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Procedimientos procedimientos) {

		StringBuilder where = new StringBuilder(ProcedimientosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (procedimientos != null && procedimientos.getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(procedimientos.getIdProcedimiento());
		}
		if (procedimientos != null && procedimientos.getDirecciones() != null
				&& procedimientos.getDirecciones().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(procedimientos.getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getCodProcedureId() != null) {
			where.append(" AND t1.COD_PROCEDURE_ID = ?");
			params.add(procedimientos.getCodProcedureId());
		}
		if (procedimientos != null && procedimientos.getCamposTituloExpediente() != null) {
			where.append(" AND t1.CAMPOS_TITULO_EXPEDIENTE = ?");
			params.add(procedimientos.getCamposTituloExpediente());
		}
		if (procedimientos != null && procedimientos.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(procedimientos.getUsuarioRegistro());
		}
		if (procedimientos != null && procedimientos.getDescripcionEs() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(procedimientos.getDescripcionEs());
		}
		if (procedimientos != null && procedimientos.getDescripcionEu() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(procedimientos.getDescripcionEu());
		}
		if (procedimientos != null && procedimientos.getInicioOficio() != null) {
			where.append("AND t1.INICIO_OFICIO = ? ");
			params.add(procedimientos.getInicioOficio());
		}
		if (procedimientos != null && procedimientos.getAplicacion() != null
				&& procedimientos.getAplicacion().getCodAplicacion() != null) {
			where.append("AND t2.CODIGO_APLICACION = ? ");
			params.add(procedimientos.getAplicacion().getCodAplicacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Procedimientos entity
	 *
	 * @param procedimientos
	 *            Procedimientos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Procedimientos procedimientos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ProcedimientosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (procedimientos != null && procedimientos.getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(procedimientos.getIdProcedimiento());
		}
		if (procedimientos != null && procedimientos.getDirecciones().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(procedimientos.getDirecciones().getIdDireccion());
		}
		if (procedimientos != null && procedimientos.getCodProcedureId() != null) {
			where.append(" AND UPPER(t1.COD_PROCEDURE_ID) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getCodProcedureId().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getCodProcedureId().toUpperCase() + "%");
			}
			where.append(" AND t1.COD_PROCEDURE_ID IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getCamposTituloExpediente() != null) {
			where.append(" AND UPPER(t1.CAMPOS_TITULO_EXPEDIENTE) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getCamposTituloExpediente().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getCamposTituloExpediente().toUpperCase() + "%");
			}
			where.append(" AND t1.CAMPOS_TITULO_EXPEDIENTE IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDescripcionEs() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getDescripcionEs().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDescripcionEs().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (procedimientos != null && procedimientos.getDescripcionEu() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getDescripcionEu().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getDescripcionEu().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}

		if (procedimientos != null && procedimientos.getInicioOficio() != null) {
			where.append("AND t1.INICIO_OFICIO = ? ");
			params.add(procedimientos.getInicioOficio());
		}
		if (procedimientos != null && procedimientos.getAplicacion() != null
				&& procedimientos.getAplicacion().getCodAplicacion() != null) {
			where.append(" AND UPPER(t2.CODIGO_APLICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(procedimientos.getAplicacion().getCodAplicacion().toUpperCase() + "%");
			} else {
				params.add("%" + procedimientos.getAplicacion().getCodAplicacion().toUpperCase() + "%");
			}
			where.append(" AND t2.CODIGO_APLICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	@Override
	public Procedimientos findByProcedureId(String codProcedureId) {
		String query = "SELECT t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_DIRECCION IDDIRECCION, t1.COD_PROCEDURE_ID CODPROCEDUREID, t1.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t2.URL_APLICACION URLAPLICACION FROM PROCEDIMIENTOS t1, APLICACIONES t2 WHERE t1.ID_APLICACION = t2.ID_APLICACION(+) AND t1.COD_PROCEDURE_ID = ?  ";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMap, codProcedureId);
		return DataAccessUtils.uniqueResult(procedimientosList);
	}

	@Override
	public Procedimientos findByIdExpediente(Integer idExpediente) {
		String query = "SELECT t6101.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t6101.COD_PROCEDURE_ID CODPROCEDUREID FROM PROCEDIMIENTOS t6101, EXPEDIENTES t6102 WHERE t6101.ID_PROCEDIMIENTO = t6102.ID_PROCEDIMIENTO AND t6102.ID_EXPEDIENTE = ?";

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMapProcedureId, idExpediente);
		return DataAccessUtils.uniqueResult(procedimientosList);
	}

	@Override
	public List<Procedimientos> findAllProcedimientosAplicacion(Procedimientos procedimientos) {
		List<Object> params = new ArrayList<Object>();
		String query = "SELECT t6101.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t6101.ID_DIRECCION IDDIRECCION, "
				+ " t6101.COD_PROCEDURE_ID CODPROCEDUREID, t6101.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, "
				+ " t6101.FECHA_REGISTRO FECHAREGISTRO, t6101.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t6101.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t6101.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA "
				+ " FROM PROCEDIMIENTOS t6101, APLICACIONES t6146 WHERE 1 = 1 AND t6101.ID_APLICACION = t6146.ID_APLICACION AND (SELECT COUNT(1) FROM REL_LIS_PRO t6105 WHERE t6101.ID_PROCEDIMIENTO = t6105.ID_PROCEDIMIENTO) > 0 ";

		if (procedimientos.getAplicacion() != null && procedimientos.getAplicacion().getCodAplicacion() != null
				&& !procedimientos.getAplicacion().getCodAplicacion().equals("")) {
			query += " AND UPPER(t6146.CODIGO_APLICACION) = UPPER(?) ";
			params.add(procedimientos.getAplicacion().getCodAplicacion());
		}
		query += " UNION "

				+ " SELECT t6101.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t6101.ID_DIRECCION IDDIRECCION, "
				+ " t6101.COD_PROCEDURE_ID CODPROCEDUREID, t6101.CAMPOS_TITULO_EXPEDIENTE CAMPOSTITULOEXPEDIENTE, "
				+ " t6101.FECHA_REGISTRO FECHAREGISTRO, t6101.USUARIO_REGISTRO USUARIOREGISTRO, "
				+ " t6101.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t6101.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA "
				+ " FROM PROCEDIMIENTOS t6101, APLICACIONES t6146, REL_LIS_PRO_APL t6165, REL_LIS_PRO t6105 "
				+ " WHERE 1 = 1 AND t6165.ID_APLICACION = t6146.ID_APLICACION "
				+ " AND t6105.ID_REL_LIS_PRO = t6165.ID_REL_LIS_PRO AND t6101.ID_PROCEDIMIENTO = t6105.ID_PROCEDIMIENTO ";

		if (procedimientos.getAplicacion() != null && procedimientos.getAplicacion().getCodAplicacion() != null
				&& !procedimientos.getAplicacion().getCodAplicacion().equals("")) {
			query += " AND UPPER(t6146.CODIGO_APLICACION) = UPPER(?) ";
			params.add(procedimientos.getAplicacion().getCodAplicacion());
		}

		List<Procedimientos> procedimientosList = this.jdbcTemplate.query(query, this.rwMapListados, params.toArray());
		return procedimientosList;
	}

	@Override
	public boolean esProcedimientoInicioOficio(Integer idProcedimiento) {
		String query = "SELECT COUNT(1) FROM REL_INI_OFI_ORI t6103, PROCEDIMIENTOS t6101 WHERE t6103.ID_PROC_ORIGEN = ? AND  t6103.ID_PROC_INICIO_OFICIO = t6101.ID_PROCEDIMIENTO AND t6101.INICIO_OFICIO = ?";

		List<Object> params = new ArrayList<Object>();
		params.add(idProcedimiento);
		params.add(Constantes.PROCEDIMIENTO_INICIO_OFICIO);

		Long procedimientosCount = this.jdbcTemplate.queryForObject(query, params.toArray(), Long.class);

		if (procedimientosCount > 0) {
			return true;
		} else {
			return false;
		}
	}
}
